<?php

require_once(SK_CLASS_PATH.'/com/gairegroup/php/customposts/GenericPostType.php');

require_once(SK_CLASS_PATH.'/com/gairegroup/php/options_handler.php');

/**

 * Youtube CPT

 */

class YoutubeCPT extends VKGenericPostType {

	

	/* VIDEO CONTAINER

	================================================== */

	public function video_metabox(){

		global $post;

		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)

			return $post_id;

			

			$sk_options = new SKVidOptionsHandler();

			

			$custom = get_post_meta($post->ID, $this->getPostSlug().'-data', false);

			

			//video size

			$defaultVideoSize = $sk_options->getDefaultVideoSize();

			$vidWidth = $defaultVideoSize['vidWidth'];

			$vidHeight = $defaultVideoSize['vidHeight'];

			

			//video ID

			$videoID = "";

			

			//main json data

			$mainJSONData = "";

			

			if(isset($custom[0])){

				$vidWidth = wptexturize($custom[0]['vidWidth']);

				$vidHeight = wptexturize($custom[0]['vidHeight']);

				$videoID = wptexturize($custom[0]['videoID']);

				$mainJSONData = (isset($custom[0]['mainJSONData']))?$mainJSONData = $custom[0]['mainJSONData']:"";

			}				

		?>

		

	<!--boxes wrapper-->

	<div class="metabox_wrapper">			

		

		

		<!--shortcode-->

		<div class="contentBox">

			<label class="customLabel"><?php _e('Shortcode:', SK_TEXTDOMAIN);?>  <span id="shortcode" data-postid="<?php echo $post->ID;?>" class="sk_defaultText"><?php echo '[vap id="'.$post->ID.'"]';?></span></label>

		</div>

		<!--/shortcode-->

											

					

		<!--get video-->

		<div class="contentBox">

			<input id="videoID" class="inputText" placeholder="video id" type="text" name="<?php echo $this->getPostSlug().'-data'?>[videoID]" value="<?php echo $videoID;?>" />

			<a id="getVidBTN" class="button-primary" style="background-color: #6c90eb;"><?php _e('Get video', SK_TEXTDOMAIN);?></a>

		</div>

		<!--/get video-->

		

		

		<!--video size-->

		<div class="contentBox">

			<label class="customLabel marginRightMedium"><?php _e('Max width:', SK_TEXTDOMAIN);?></label>

			<input id="vidWidth" class="inputText" type="text" name="<?php echo $this->getPostSlug().'-data'?>[vidWidth]" value="<?php echo $vidWidth;?>" />

			<label class="customLabel marginRightMedium"><?php _e('Max height:', SK_TEXTDOMAIN);?></label>

			<input id="vidHeight" class="inputText" type="text" name="<?php echo $this->getPostSlug().'-data'?>[vidHeight]" value="<?php echo $vidHeight;?>" />

			<a id="newSizeBTN" class="button-primary" style="background-color: #6c90eb;"><?php _e('Size it up', SK_TEXTDOMAIN);?></a>

		</div>

		<!--/video size-->		

		

		

		<!--video container-->

		<div id="videoContainer" class="contentBox">

			<div id="videoContent"></div>						

		</div>

		<!--/video container-->	

		

		

		

		<!--add assets-->

		<div id="mainControlButtons" style="float: right; width: 150px; visibility: visible; background-color: #acd;" class="contentBox">
			<div width="100%" style="background-color: #6c90eb;  color: #fff;font-size: 16px;height: 22px;padding-top: 2px;">
			  <span>GAIRE DASHBOARD</span>
			</div>
			<a id="addButtonBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add button', SK_TEXTDOMAIN);?></a>
			<a id="addFormBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add form', SK_TEXTDOMAIN);?></a>
			<a id="addTextBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add text', SK_TEXTDOMAIN);?></a>
			<a id="addImageBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add image', SK_TEXTDOMAIN);?></a>
			<a id="addRectangleBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add rectangle', SK_TEXTDOMAIN);?></a>
			
			<a id="addCodeBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px;"><?php _e('Add code', SK_TEXTDOMAIN);?></a>
			
			<a id="previewBTN" class="button-primary" style="background-color: #6c90eb; width: 75%;  margin-top: 10px; margin-bottom: 10px;"><?php _e('Preview', SK_TEXTDOMAIN);?></a>
			<a href="http://gairegroup.com/current/" target=_blank> <img src = "http://gairegroup.com/myimage.png" style="width: 100%; height: 100px;"></a>
		</div>
		<!--/add assets-->	

		

		

		

		<!--json data-->

		<textarea id="mainJSONData" class="boxContentTextarea" name="<?php echo $this->getPostSlug().'-data'?>[mainJSONData]" rows="4"><?php echo $mainJSONData; ?></textarea>

		<!--/json data-->

		

	</div>

	<!--/boxes wrapper-->

		<?php		

	}

	

	/* PROPERTIES CONTAINER

	================================================== */

	public function properties_metabox(){

		global $post;

		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)

			return $post_id;

		?>

		

		<!--properties container-->

		<div id="propertiesContainer">

	

		</div>

		<!--/properties container-->		

		

		

		<?php		

	}

	

	/* TIMELINE CONTAINER

	================================================== */

	public function customprop_metabox(){

		global $post;

		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)

			return $post_id;

		?>

		

		<!--properties container-->

		<div id="custompropContainer" class="contentBoxPropBottm">

		

		</div>

		<!--/properties container-->

		

		<?php		

	}	

		

}





?>