<?php

/**
 * Options handler
 */
class SKVidOptionsHandler {
	
	//get options
	public function getOptions(){
		$skOptions = get_option('skOptions');
		return $skOptions;
	}
	
	//get specific option
	public function getSpecificOption($val){
		$skOptions = $this->getOptions();
		return (isset($skOptions[$val]))?$skOptions[$val]:'null-option';
	}
	
	//get default vid size
	public function getDefaultVideoSize($value=''){
		$skOptions = $this->getOptions();
		$w = (isset($skOptions['vidWidth']))?$skOptions['vidWidth']:VIDEO_W;
		$h = (isset($skOptions['vidHeight']))?$skOptions['vidHeight']:VIDEO_H;
		return array('vidWidth'=>$w, 'vidHeight'=>$h);
	}	
}

?>